--#################################################################################################
-- 2025-06-03 08:56:35.599 MachineName:ViscosityLowell; ComputerBiosName:VISCOSITYLOWELL;  
-- ApplicationName: DBA | AppEmailGroup: lowell.izaguirre@viscosityna.com | ServerUptime[dd:hh:mm:ss]: 02:02:12:22
-- Cname: wks-lowell.workgroup,;  LoginName: VISCOSITYLOWELL\lowell Authorization Scheme: NTLM viscositylowell
-- Context: ViscosityLowell,; Database:SampleDB_Clone; Version: [SQL 2022 || 16.0.4165.4] Developer Edition (64-bit)
--#################################################################################################
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
--desc: creates functions to read extended events
USE [master];
GO
--#################################################################################################
-- Real World DBA Toolkit version 4.94 Lowell Izaguirre lowell@stormrage.com
--this solution creates functions to read either ring_buffer or event_file, but the jobs assume ring_buffer
--event_file type EE's  can be very difficult to drop and create on a busy system
--the procedures to do that will hang, waiting on exlusive access, not worth the trouble, just use ring_buffer and read it frequently.
--#################################################################################################

--#################################################################################################
-- Parameters To Change:
--#################################################################################################
DECLARE @SessionName       VARCHAR(128) = 'system_health';         -- = 'DDLChanges','LoginTracking', etc
DECLARE @JobOperatorName   VARCHAR(128) 
DECLARE @EmailGroupsToSend VARCHAR(max)
SELECT @JobOperatorName = [name], @EmailGroupsToSend =[email_address]  
FROM msdb.dbo.[sysoperators] ORDER BY id DESC -- the first operator, or maybe NULL
--SET  @EmailGroupsToSend = 'thedbaGroup@yourdomain.com' -- semicolon delimited, and better to use a Distribution List, not individual emails

--#################################################################################################
DECLARE @sysadminname VARCHAR(128)
SELECT @sysadminname = [name] FROM sys.server_principals WHERE sid = 0x01 --my [sa] account was renamed to 'Keyser.Soze'

IF OBJECT_ID('tempdb.[dbo].[#Results]') IS NOT NULL 
DROP TABLE [dbo].[#Results] 

CREATE TABLE [dbo].[#Results] ( 
[SessionName]          VARCHAR(128)                            NULL,
[TargetName]           VARCHAR(128)                            NULL,
[SessionDefinition]    VARCHAR(max)                            NULL,
[FunctionDefinition]   VARCHAR(max)                            NULL,
[DropCommands]         VARCHAR(max)                            NULL,
[TableDefinition]      VARCHAR(max)                            NULL,
[ProcedureDefinitions] VARCHAR(max)                            NULL,
[JobDefinition]        VARCHAR(max)                            NULL,
[RptJobDefinition]     VARCHAR(max)                            NULL)


--DECLARE @SessionName VARCHAR(128) = 'DDLChanges'  -- = NULL; -- = 
;WITH Prerequisite
AS
(
SELECT [sess].[name] As SessionName,
[targz].[target_name] As TargetName,
DropCommands = '/*
IF EXISTS ( SELECT * FROM sys.server_event_sessions WHERE name = ''' + [sess].[name] + ''' )
  DROP EVENT SESSION [' + [sess].[name] + '] ON SERVER;
  */
GO
USE [msdb];
GO
IF OBJECT_ID(''[dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']'') IS NOT NULL 
DROP TABLE [dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']; 
GO
IF OBJECT_ID(''[dbo].[usp_DBA' + REPLACE([sess].[name],' ','_') + ']'') IS NOT NULL 
DROP  PROCEDURE [dbo].[usp_DBA' + REPLACE([sess].[name],' ','_') + ']; 
GO
IF OBJECT_ID(''[dbo].[usp_CYCLE_' + REPLACE([sess].[name],' ','_') + ']'') IS NOT NULL 
DROP  PROCEDURE [dbo].[usp_CYCLE_' + REPLACE([sess].[name],' ','_') + ']; 
GO
IF EXISTS(SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(''[dbo].[fnExtendedEvent_' + REPLACE([sess].[name],' ','_') + ']'')) 
DROP FUNCTION [dbo].[fnExtendedEvent_' + REPLACE([sess].[name],' ','_') + ']
GO
IF  EXISTS (SELECT * FROM [msdb].[dbo].[sysjobs] WHERE name = N''DBA_' + REPLACE([sess].[name],' ','_') + ''')
  EXECUTE [msdb].[dbo].[sp_delete_job] @job_name=N''DBA_' + REPLACE([sess].[name],' ','_') + ''', @delete_unused_schedule=1;
GO
IF  EXISTS (SELECT * FROM [msdb].[dbo].[sysjobs] WHERE name = N''DBA_Rpt_' + REPLACE([sess].[name],' ','_') + ''')
  EXECUTE [msdb].[dbo].[sp_delete_job] @job_name=N''DBA_Rpt_' + REPLACE([sess].[name],' ','_') + ''', @delete_unused_schedule=1;
GO',
TableDefinition =' 
USE [msdb];
GO
IF OBJECT_ID(''[dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']'') IS NOT NULL 
DROP  TABLE  [dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']
GO
USE [msdb];
GO
CREATE TABLE  [dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']
(
[EventTimestamp]                  DATETIME2                                   NULL,
[EventName]                       VARCHAR(128)                                NULL,
[PackageName]                     VARCHAR(128)                                NULL,
[SessionIdentifier]               INT                                         NULL,
[PackageVersion]                  INT                                         NULL',
ProceduresCmd = 'IF OBJECT_ID(''[dbo].[usp_DBA' + REPLACE([sess].[name],' ','_') + ']'') IS NOT NULL 
DROP  PROCEDURE [dbo].[usp_DBA' + REPLACE([sess].[name],' ','_') + '] 
GO
USE [msdb];
GO
CREATE PROCEDURE [dbo].[usp_DBA' + REPLACE([sess].[name],' ','_') + '] 
AS
BEGIN
--this procedure is doing blind inserts, but ideally you would want to change this
--to use insert update, based on specific columns to group by to avoid a billion row logging
INSERT INTO [dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']
SELECT *  FROM [dbo].[fnExtendedEvent_' + REPLACE([sess].[name],' ','_') + ']() 
END
GO
USE [msdb];
GO
IF OBJECT_ID(''[dbo].[usp_CYCLE_' + REPLACE([sess].[name],' ','_') + ']'') IS NOT NULL 
DROP  PROCEDURE [dbo].[usp_CYCLE_' + REPLACE([sess].[name],' ','_') + '] 
GO
--#################################################################################################
--  PROCEDURE [dbo].[usp_CYCLE_' + REPLACE([sess].[name],' ','_') + ']
--#################################################################################################
CREATE PROCEDURE [dbo].[usp_CYCLE_' + REPLACE([sess].[name],' ','_') + '] @SetStatus VARCHAR(3)
AS
BEGIN --PROC
DECLARE @ee VARCHAR(128) = ''' + REPLACE([sess].[name],' ','_') + ''';
 BEGIN
  IF @SetStatus = ''OFF''
    BEGIN
     --try it twice
      IF EXISTS (SELECT COUNT(name) FROM sys.dm_xe_sessions WHERE name = @ee GROUP BY name HAVING COUNT(name) = 1 )
        ALTER EVENT SESSION [' + REPLACE([sess].[name],' ','_') + '] ON SERVER STATE = STOP;
        WAITFOR DELAY ''00:00:01''
       IF EXISTS (SELECT COUNT(name) FROM sys.dm_xe_sessions WHERE name = @ee GROUP BY name HAVING COUNT(name) = 1 )
        ALTER EVENT SESSION [' + REPLACE([sess].[name],' ','_') + '] ON SERVER STATE = STOP;
    END
   ELSE --@SetStatus = ON -turn it on
     BEGIN
       --try it twice
      IF NOT EXISTS (SELECT COUNT(name) FROM sys.dm_xe_sessions WHERE name = @ee GROUP BY name HAVING COUNT(name) = 1 )
        ALTER EVENT SESSION [' + REPLACE([sess].[name],' ','_') + '] ON SERVER STATE = START;
        WAITFOR DELAY ''00:00:01''
       IF NOT EXISTS (SELECT COUNT(name) FROM sys.dm_xe_sessions WHERE name = @ee GROUP BY name HAVING COUNT(name) = 1 )
        ALTER EVENT SESSION [' + REPLACE([sess].[name],' ','_') + '] ON SERVER STATE = START;
     END
 END;
END; -- PROC
GO
',
JobCommand = 
'
--#################################################################################################
-- Create the Job
--#################################################################################################
USE [msdb]
GO

/****** Object:  Job [DBA_' + REPLACE([sess].[name],' ','_') + '] ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [Data Collector] ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N''Data Collector'' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N''JOB'', @type=N''LOCAL'', @name=N''Data Collector''
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N''DBA_' + REPLACE([sess].[name],' ','_') + ''', 
@enabled=1, 
@notify_level_eventlog=3, 
@notify_level_email=2, 
@notify_level_netsend=0, 
@notify_level_page=0, 
@delete_level=0, 
@description=N''Logs Events into DBA' + REPLACE([sess].[name],' ','_') + ''', 
@category_name=N''Data Collector'', 
@owner_login_name=N''' + @sysadminname + ''', 
@notify_email_operator_name=N''' + @JobOperatorName + ''',
@job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [LogEventErrorCapture] ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N''DBA_' + REPLACE([sess].[name],' ','_') + ''', 
@step_id=1, 
@cmdexec_success_code=0, 
@on_success_action=3, 
@on_success_step_id=0, 
@on_fail_action=2, 
@on_fail_step_id=0, 
@retry_attempts=0, 
@retry_interval=0, 
@os_run_priority=0, @subsystem=N''TSQL'', 
@command=N''
EXEC [dbo].[usp_DBA' + REPLACE([sess].[name],' ','_') + ']
'', 
    @database_name=N''msdb'', 
    @flags=4
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cycle' + REPLACE([sess].[name],' ','_') + ' OFF] ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N''Cycle' + REPLACE([sess].[name],' ','_') + ' OFF'', 
@step_id=2, 
@cmdexec_success_code=0, 
@on_success_action=3, 
@on_success_step_id=0, 
@on_fail_action=2, 
@on_fail_step_id=0, 
@retry_attempts=0, 
@retry_interval=0, 
@os_run_priority=0, @subsystem=N''TSQL'', 
@command=N''EXEC usp_Cycle_' + REPLACE([sess].[name],' ','_') + '   @SetStatus = ''''OFF'''';'', 
@database_name=N''msdb'', 
@flags=4
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Cycle' + REPLACE([sess].[name],' ','_') + ' ON]  ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N''Cycle' + REPLACE([sess].[name],' ','_') + ' ON'', 
@step_id=3, 
@cmdexec_success_code=0, 
@on_success_action=1, 
@on_success_step_id=0, 
@on_fail_action=2, 
@on_fail_step_id=0, 
@retry_attempts=0, 
@retry_interval=0, 
@os_run_priority=0,
@subsystem=N''TSQL'', 
@command=N''Exec usp_Cycle_' + REPLACE([sess].[name],' ','_') + '   @SetStatus = ''''ON'''';'', 
@database_name=N''msdb'', 
@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N''DBA' + REPLACE([sess].[name],' ','_') + ''', 
@enabled=1, 
@freq_type=4, 
@freq_interval=1, 
@freq_subday_type=4, 
@freq_subday_interval=5, 
@freq_relative_interval=0, 
@freq_recurrence_factor=0, 
@active_start_date=20140110, 
@active_end_date=99991231, 
@active_start_time=0, 
@active_end_time=235959, 
@schedule_uid=N''a53a7018-0bc1-4975-976f-e0d55451c5b3''
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N''(local)''
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:
GO
',
RptJobCommand = 
'
--#################################################################################################
-- Create the Report Job
--#################################################################################################
USE [msdb]
GO

/****** Object:  Job [DBA_Rpt_' + REPLACE([sess].[name],' ','_') + ']    Script Date: 9/16/2020 3:12:42 PM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [Data Collector]    Script Date: 9/16/2020 3:12:42 PM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N''Data Collector'' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N''JOB'', @type=N''LOCAL'', @name=N''Data Collector''
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N''DBA_Rpt_' + REPLACE([sess].[name],' ','_') + ''', 
    @enabled=1, 
    @notify_level_eventlog=3, 
    @notify_level_email=2, 
    @notify_level_netsend=0, 
    @notify_level_page=0, 
    @delete_level=0, 
    @description=N''Sends Email Report for Events in DBA Rpt' + REPLACE([sess].[name],' ','_') + ''', 
    @category_name=N''Data Collector'', 
    @owner_login_name=N''' + @sysadminname + ''', 
    @notify_email_operator_name=N''' + @JobOperatorName + ''',
    @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Execute sp_MailTableResultsASHTML]    Script Date: 9/16/2020 3:12:43 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N''Execute sp_MailTableResultsASHTML'', 
    @step_id=1, 
    @cmdexec_success_code=0, 
    @on_success_action=3, 
    @on_success_step_id=0, 
    @on_fail_action=2, 
    @on_fail_step_id=0, 
    @retry_attempts=0, 
    @retry_interval=0, 
    @os_run_priority=0,
    @subsystem=N''TSQL'', 
    @command=N''
        EXECUTE sp_MailTableResultsASHTML @TableName = ''''[dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']'''',@TOP = 0,@EmailRecipient = ''''' + @EmailGroupsToSend + ''''',@MailProfile = '''''''',@IncludeDataAsAttachment = 1;
'', 
    @database_name=N''msdb'', 
    @flags=4
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step TRUNCATE [dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']    Script Date: 9/16/2020 3:12:43 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N''TRUNCATE TABLE [dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']'', 
    @step_id=2, 
    @cmdexec_success_code=0, 
    @on_success_action=3, 
    @on_success_step_id=0, 
    @on_fail_action=2, 
    @on_fail_step_id=0, 
    @retry_attempts=0, 
    @retry_interval=0, 
    @os_run_priority=0, @subsystem=N''TSQL'', 
    @command=N''TRUNCATE TABLE [dbo].[DBA' + REPLACE([sess].[name],' ','_') + ']'', 
    @database_name=N''msdb'', 
    @flags=4
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N''DBA_Rpt_' + REPLACE([sess].[name],' ','_') + ''', 
    @enabled=1, 
    @freq_type=8, 
    @freq_interval=2, 
    @freq_subday_type=1, 
    @freq_subday_interval=5, 
    @freq_relative_interval=0, 
    @freq_recurrence_factor=1, 
    @active_start_date=20140110, 
    @active_end_date=99991231, 
    @active_start_time=70000, 
    @active_end_time=235959
    --@schedule_uid=N''a53a7018-0bc1-4975-976f-e0d55451c5b3''
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N''(local)''
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:
GO
USE master;
GO
IF OBJECT_ID(''[dbo].[sp_MailTableResultsASHTML]'') IS NOT NULL 
DROP  PROCEDURE [dbo].[sp_MailTableResultsASHTML] 
GO
--EXECUTE sp_MailTableResultsASHTML ''ServerInventory'',0,''lowell@stormrage.com'','''',1
CREATE PROCEDURE sp_MailTableResultsASHTML( @TableName VARCHAR(256),
                                            @TOP int                     = 0,
                                            @EmailRecipient VARCHAR(MAX) = '''',
                                            @MailProfile VARCHAR(128)    = '''',
                                            @IncludeDataAsAttachment INT = 1)
AS
BEGIN
IF @MailProfile ='''' SET @MailProfile = NULL;
IF OBJECT_ID(''tempdb..#DynamicResults'') IS NOT NULL DROP TABLE #DynamicResults
--DECLARE @TableName VARCHAR(256) = ''SqlServerVersions'' ,@TOP int = 0
Declare @HTMLBody   VARCHAR(max),
      @TableHead    VARCHAR(max),
      @TableContent VARCHAR(max),
      @TableTail    VARCHAR(max),
      @ColumnNames  VARCHAR(max),
      @SQLQuery     VARCHAR(max)
DECLARE @FullyQualifiedQuery VARCHAR(MAX)
DECLARE @FullyQualifiedTableName VARCHAR(392) --128 chars + 2periods plus 6 brackets

DECLARE @ResultsFileName VARCHAR(256) = @TableName + ''.txt''
SELECT @TableContent = ''''
SET NOCOUNT ON;
Set @TableTail = ''</table></body></html>'';
--note defining fancy css here can be done, but a lot of mail readers like Gmail,outlook, etc stip out fancy css, so I''m stickign with simpler code. fee free to fancy it up to your own preferences.
Set @TableHead = ''<html><head>'' 
                  + ''<style>'' 
                  + ''th {border: solid black 1px;padding-left:5px;padding-right:5px;padding-top:1px;padding-bottom:1px;font-size:13pt;font-weight:bold;background-color:#DDDDDD;} '' 
                  + ''td {border: solid black 1px;padding-left:5px;padding-right:5px;padding-top:1px;padding-bottom:1px;font-size:11pt;} '' 
                  + ''</style>'' 
                  + ''</head>'' 
                  + ''<body><table cellpadding=0 cellspacing=0 border=0>
                  '' 
                  

--#################################################################################################
-- get the column names nicely formatted
--#################################################################################################

  IF LEFT(@TableName,1) = ''#''
  BEGIN
    SELECT @FullyQualifiedQuery = ''SELECT * FROM ''+ QUOTENAME(@TableName)
    SELECT @FullyQualifiedTableName = QUOTENAME(@TableName)
    SELECT @TableHead = @TableHead + (SELECT DISTINCT
       ''<tr>'' + sq.Columns + ''</tr>'' + CHAR(13) + CHAR(10)
    FROM tempdb.sys.tables t
         JOIN (
              SELECT OBJECT_ID, 
                     Columns = STUFF((SELECT '' '' + ''<th>'' + QUOTENAME(name) + ''</th>''
                                        FROM  tempdb.sys.columns sc
                                       WHERE sc.object_id = s.object_id
                                       AND sc.object_id = OBJECT_ID(''tempdb..'' + @TableName)
                                      FOR XML PATH(''''), TYPE).value(''.'',''varchar(max)''),1,1,'''')
                FROM  tempdb.sys.columns s 
              ) sq ON t.object_id = sq.object_id
    WHERE t.object_id = OBJECT_ID(''tempdb..'' + @TableName))
    --------------------------
    --@ColumnNames
    --------------------------
    SELECT @ColumnNames = (SELECT DISTINCT
        ''SELECT '' + CASE WHEN @TOP > 0 THEN ''TOP '' + CONVERT(VARCHAR,@TOP) + '' '' ELSE '' '' END + '' ROW_NUMBER() Over(Order By (SELECT NULL)) % 2 As [TRRow],'' 
        + CHAR(13) + CHAR(10) +  sq.Columns  + CHAR(13) + CHAR(10)
    FROM tempdb.sys.tables t
         JOIN (
              SELECT OBJECT_ID, 
                     Columns = STUFF((SELECT '','' + ''  '' + QUOTENAME(name) + '' AS [TD]''
                                        FROM  tempdb.sys.columns sc
                                       WHERE sc.object_id = s.object_id
                                       AND sc.object_id = OBJECT_ID(''tempdb..'' + @TableName)
                                      FOR XML PATH(''''), TYPE).value(''.'',''varchar(max)''),1,1,'''')
                FROM  tempdb.sys.columns s 
              ) sq ON t.object_id = sq.object_id
    WHERE t.object_id = OBJECT_ID(''tempdb..'' + @TableName))
  END
  ELSE
  BEGIN
    SELECT @FullyQualifiedQuery = ''SELECT * FROM ''+ QUOTENAME(DB_NAME()) + ''.'' + QUOTENAME(OBJECT_SCHEMA_NAME(OBJECT_ID(@TableName))) + ''.'' + QUOTENAME(OBJECT_NAME(OBJECT_ID(@TableName)))
    SELECT @FullyQualifiedTableName = QUOTENAME(DB_NAME()) + ''.'' + QUOTENAME(OBJECT_SCHEMA_NAME(OBJECT_ID(@TableName))) + ''.'' + QUOTENAME(OBJECT_NAME(OBJECT_ID(@TableName)))

    SELECT @TableHead = @TableHead + (SELECT DISTINCT
       ''<tr>'' + sq.Columns + ''</tr>''
    FROM sys.tables t
         JOIN (
              SELECT OBJECT_ID, 
                     Columns = STUFF((SELECT '' '' + ''<th>'' + QUOTENAME(name) + ''</th>''
                                        FROM  sys.columns sc
                                       WHERE sc.object_id = s.object_id
                                       AND sc.object_id = OBJECT_ID(@TableName)
                                      FOR XML PATH(''''), TYPE).value(''.'',''varchar(max)''),1,1,'''')
                FROM  sys.columns s 
              ) sq ON t.object_id = sq.object_id
    WHERE t.object_id = OBJECT_ID(@TableName))
        --------------------------
    --@ColumnNames
    --------------------------
    SELECT @ColumnNames = (SELECT DISTINCT
        ''SELECT '' + CASE WHEN @TOP > 0 THEN ''TOP '' + CONVERT(VARCHAR,@TOP) + '' '' ELSE '' '' END + '' Row_Number() Over(Order By (SELECT NULL)) % 2 As [TRRow],''   
        + CHAR(13) + CHAR(10) +  sq.Columns  + CHAR(13) + CHAR(10)
    FROM sys.tables t
         JOIN (
              SELECT OBJECT_ID, 
                     Columns = STUFF((SELECT '','' + ''  '' + QUOTENAME(name) + '' AS [TD]''
                                        FROM  sys.columns sc
                                       WHERE sc.object_id = s.object_id
                                       AND sc.object_id = OBJECT_ID(@TableName)
                                      FOR XML PATH(''''), TYPE).value(''.'',''varchar(max)''),1,1,'''')
                FROM  sys.columns s 
              ) sq ON t.object_id = sq.object_id
    WHERE t.object_id = OBJECT_ID(@TableName))
  END
--#################################################################################################
-- get the body
--#################################################################################################
--build a query for dynamic SQL

CREATE TABLE #DynamicResults(ResultsText VARCHAR(MAX))
  SELECT @SQLQuery = ''SELECT (''
                     + @ColumnNames
                     + '' FROM ''
                     + @TableName
                     + '' FOR XML raw(''''tr''''), Elements''
                     + '') ''
  --PRINT @SQLQuery
  INSERT INTO #DynamicResults
    EXECUTE (@SQLQuery)
--cleanup rownumber and empty strings with nonbreaking space &nbsp;
 SELECT @TableContent = (SELECT REPLACE(
                                REPLACE(
                                REPLACE(
                                REPLACE(
                                REPLACE(ResultsText,''<TD></TD>'',''<TD>&nbsp;</TD>'')
                                                    ,''_x0020_'', space(1))
                                                    ,''_x003D_'', ''='')
                                                    ,''<tr><TRRow>1</TRRow>'', ''<tr bgcolor=#C6CFFF>'')
                                                    ,''<TRRow>0</TRRow>'', '''') FROM #DynamicResults)
 
--#################################################################################################
-- output the concatenated string.
--#################################################################################################
SELECT @HTMLBody = @TableHead + @TableContent +  @TableTail
SELECT @ResultsFileName = @FullyQualifiedTableName +''.txt''
--#################################################################################################
-- send the email
--#################################################################################################
IF @EmailRecipient > '''' AND @EmailRecipient LIKE ''[a-z]%@%[.][a-z][a-z]%''
BEGIN
    IF @IncludeDataAsAttachment = 1
      BEGIN
          EXEC msdb.dbo.sp_send_dbmail 
              @profile_name = @MailProfile,
              @recipients = @EmailRecipient,
              @subject = @FullyQualifiedTableName,
              @body =@HTMLBody,
              @body_format = ''HTML'',
              @query = @FullyQualifiedQuery, --this must reference  fullyqualified DatabaseName.SchemaName.TableName
              @query_result_header = 0,
              @exclude_query_output = 1,
              @append_query_error = 1,
              @attach_query_result_as_file = 1,
              @query_attachment_filename = @ResultsFileName,
              @query_result_no_padding = 1
      END
    ELSE
      BEGIN
        EXEC msdb.dbo.sp_send_dbmail 
         @profile_name = @MailProfile,
         @recipients = @EmailRecipient,
        @subject = @FullyQualifiedTableName,
        @body =@HTMLBody,
        @body_format = ''HTML''
      END
    END

END --PROC
GO
EXECUTE sp_ms_marksystemobject ''dbo.sp_MailTableResultsASHTML''


',
precmd = '
USE [msdb];
GO
IF EXISTS(SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(''[dbo].[fnExtendedEvent_' + REPLACE([sess].[name],' ','_') + ']'')) 
DROP FUNCTION [dbo].[fnExtendedEvent_' + REPLACE([sess].[name],' ','_') + ']
GO
-- SELECT * FROM [dbo].[fnExtendedEvent_' + REPLACE([sess].[name],' ','_') + ']() 
--#################################################################################################
-- ' + [sess].[name] + '
--#################################################################################################
CREATE FUNCTION [dbo].[fnExtendedEvent_' + REPLACE([sess].[name],' ','_') + ']() 
RETURNS @returntable TABLE 
(
[EventTimestamp]                  DATETIME2                                   NULL,
[EventName]                       VARCHAR(128)                                NULL,
[PackageName]                     VARCHAR(128)                                NULL,
[SessionIdentifier]               INT                                         NULL,
[PackageVersion]                  INT                                         NULL',
midcmd = '
)
AS 
BEGIN
DECLARE @xml XML;
SELECT  @xml = tgtz.target_data
    FROM   sys.dm_xe_session_targets tgtz
            JOIN sys.dm_xe_sessions sess
              ON tgtz.event_session_address = sess.address
    WHERE  sess.name = ''' + [sess].[name] + '''; 
INSERT INTO @returntable
SELECT 
n.value(''(@timestamp)[1]'', ''datetime2'') AS [EventTimestamp]
,n.value(''(@name)[1]'', ''varchar(128)'')     AS EventName
,n.value(''(@package)[1]'', ''varchar(128)'') AS PackageName
,n.value(''(@id)[1]'', ''int'')              AS SessionIdentifier
,n.value(''(@version)[1]'', ''int'')         AS PackageVersion',
pstcmd = 
CASE 
WHEN [targz].[target_name] = 'ring_buffer'
THEN 'FROM 
(SELECT
    @xml AS event_data
) as tab
CROSS APPLY event_data.nodes(''RingBufferTarget/event'') as q(n)
----#################################################################################################
RETURN
END
GO
'
ELSE 'FROM 
(SELECT
    CAST(event_data AS XML) AS event_data
FROM sys.fn_xe_file_target_read_file(N''' + [sess].[name] + '*.xel'',null, null, null) 
) as tab
CROSS APPLY event_data.nodes(''event'') as q(n)
----#################################################################################################
RETURN
END
GO
'
END
from [sys].[dm_xe_sessions] sess
  INNER JOIN [sys].[dm_xe_session_targets] AS targz
    ON [sess].[address] = [targz].[event_session_address] 
WHERE [targz].[target_name] IN('event_file', 'ring_buffer') --ring_buffer or event_file
AND ([sess].[name] = @SessionName )--OR @SessionName IS NULL)
)
--SELECT * FROM Prerequisite
,MyDataCTE
AS
(
SELECT ROW_NUMBER() OVER(PARTITION BY [obcolz].[name] ORDER BY (SELECT NULL)) AS RW,
[sess].[name] AS SessionName ,
[targz].[target_name] AS TargetName,
[evtz].[event_name] AS EventName,
[obcolz].[name] AS EventColumn,
[obcolz].[type_name] AS EventColumnDataType
FROM [sys].[dm_xe_sessions] sess
INNER JOIN [sys].[dm_xe_session_targets] AS targz ON [sess].[address]    = [targz].[event_session_address] 
INNER JOIN [sys].[dm_xe_session_events] evtz      ON [sess].[address]    = [evtz].[event_session_address]
INNER JOIN [sys].[dm_xe_object_columns] obcolz    ON [evtz].[event_name] = [obcolz].[object_name]
WHERE [targz].[target_name] IN('event_file', 'ring_buffer')
AND ([sess].[name] = @SessionName )--OR @SessionName IS NULL)
)
,DataCommands
AS
(
SELECT DISTINCT 
       t.SessionName,
       t.TargetName,
       ISNULL(',' + sq.Defs,'') AS ScriptedColumns,
       ISNULL(',' + sq.Columns,'') AS ScriptedNodes
  FROM MyDataCTE t
       JOIN (
             SELECT 
               SessionName, 
               TargetName,
                Defs = (STUFF((SELECT ',' + QUOTENAME(EventColumn) + '    ' 
                       + CASE 
                           WHEN EventColumnDataType = 'Int32'
                           THEN 'int'
                           WHEN EventColumnDataType = 'boolean'
                           THEN 'bit'
                           ELSE 'varchar(max)'
                           END   + CHAR(13) + CHAR(10)
                                  FROM MyDataCTE sc
                                 WHERE sc.SessionName = s.SessionName AND sc.TargetName = s.TargetName AND sc.RW = 1
                                   FOR XML PATH(''), TYPE).value('.','varchar(max)'),1,1,'')
                         ),
               Columns = (STUFF((SELECT ',' + 'n.value(''(data[@name="' + EventColumn + '"]/value)[1]'', ''' 
                       + CASE 
                           WHEN EventColumnDataType = 'Int32'
                           THEN 'int'
                           WHEN EventColumnDataType = 'boolean'
                           THEN 'bit'
                           ELSE 'varchar(max)'
                           END  +''') AS data_' + EventColumn + + CHAR(13) + CHAR(10)
                                  FROM MyDataCTE sc
                                 WHERE sc.SessionName = s.SessionName AND sc.TargetName = s.TargetName AND sc.RW = 1
                                   FOR XML PATH(''), TYPE).value('.','varchar(max)'),1,1,'')
                         )
  FROM MyDataCTE s 
) sq 
ON t.SessionName = sq.SessionName  AND t.TargetName = sq.TargetName
),
MyActionsCTE
AS
(
SELECT ROW_NUMBER() OVER(PARTITION BY actz.action_name ORDER BY (SELECT NULL)) AS RW,
[sess].[name] AS SessionName ,
[targz].[target_name] AS TargetName,
actz.action_name
from sys.[dm_xe_sessions] sess
INNER JOIN sys.dm_xe_session_targets AS targz
ON sess.address = targz.event_session_address 
AND targz.Target_name IN('event_file', 'ring_buffer')
INNER JOIN sys.dm_xe_session_events evtz
ON targz.event_session_address = evtz.event_session_address
inner join sys.dm_xe_session_event_actions actz
ON targz.event_session_address = actz.event_session_address AND evtz.event_name = actz.event_name
WHERE [targz].[target_name]IN('event_file', 'ring_buffer')
AND ([sess].[name] = @SessionName )--OR @SessionName IS NULL)
),
ActionCommands
AS
(
SELECT DISTINCT 
       t.SessionName,
       t.TargetName,
       ISNULL(',' + sq.Defs,'') AS ScriptedColumns,
       ISNULL(',' + sq.Columns,'') AS ScriptedNodes
  FROM MyDataCTE t
       JOIN (
             SELECT 
               SessionName, 
               TargetName,
                Defs = (STUFF((SELECT ',' + QUOTENAME('action_' + action_name)  + '    varchar(max)' + CHAR(13) + CHAR(10)
                                  FROM MyActionsCTE sc
                                 WHERE sc.SessionName = s.SessionName AND sc.TargetName = s.TargetName AND sc.RW = 1
                                   FOR XML PATH(''), TYPE).value('.','varchar(max)'),1,1,'')
                         ),
               Columns = (STUFF((SELECT ',' + 'n.value(''(action[@name="' + action_name + '"]/value)[1]'', ''varchar(max)'') AS action_'+ action_name + CHAR(13) + CHAR(10)
                                  FROM MyActionsCTE sc
                                 WHERE sc.SessionName = s.SessionName AND sc.TargetName = s.TargetName AND sc.RW = 1
                                   FOR XML PATH(''), TYPE).value('.','varchar(max)'),1,1,'')
                         )
  FROM MyDataCTE s 
) sq 
ON t.SessionName = sq.SessionName  AND t.TargetName = sq.TargetName
),TheData
AS
(
SELECT Prerequisite.SessionName,
       Prerequisite.TargetName,
       Prerequisite.[DropCommands],
       [FunctionDefinition] = Prerequisite.precmd
       + '
-- data
'
 + DataCommands.[ScriptedColumns]
        +'
-- actions
'
 + ActionCommands.[ScriptedColumns]
 + [Prerequisite].[midcmd]
+ '
-- data
' 
       + DataCommands.ScriptedNodes
       +'
-- actions
'
       + ActionCommands.ScriptedNodes
       + Prerequisite.pstcmd,
TableDefinitionFinal = TableDefinition + DataCommands.[ScriptedColumns] +  ActionCommands.[ScriptedColumns] + ')'
+ CHAR(13) + CHAR(10) +  'GO' + + CHAR(13) + CHAR(10),
+ ProceduresCmd AS [SupportObjects],
JobCommand AS [JobDefinition],
RptJobCommand AS [RptJobDefinition]
FROM   Prerequisite
       INNER JOIN DataCommands
               ON Prerequisite.SessionName = DataCommands.SessionName
                  AND Prerequisite.TargetName = DataCommands.TargetName
       INNER JOIN ActionCommands
               ON Prerequisite.SessionName = ActionCommands.SessionName
                  AND Prerequisite.TargetName = ActionCommands.TargetName 

)

INSERT INTO #Results ([SessionName],[TargetName],[FunctionDefinition],[DropCommands],[TableDefinition],[ProcedureDefinitions],[JobDefinition],[RptJobDefinition])
  SELECT 
    [SessionName],[TargetName],[FunctionDefinition],[DropCommands],[TableDefinitionFinal],[SupportObjects],[JobDefinition],[RptJobDefinition]
  FROM TheData
  
  --some of these definitions can exceed 4K characters, so xml time. this is so you can visualize, or do it manually, but but...xml and &lt;
  /*
  SELECT [SessionName],[TargetName],[FunctionDefinition],[DropCommands],[TableDefinition],[ProcedureDefinitions],[JobDefinition],[RptJobDefinition]
  FROM #Results
  */
  --at least visualize all the text via xml
   SELECT [SessionName],
          [TargetName],
		  [DropCommands],
		  [FunctionDefinition],
		  [TableDefinition],
		  [ProcedureDefinitions],
		  CONVERT(xml,'<A><![CDATA[' + [JobDefinition] + ']]></A>') AS [JobDefinition] ,
		  CONVERT(xml,'<A><![CDATA[' + [RptJobDefinition] + ']]></A>') AS [RptJobDefinition],
		  TheWholeBallOfWax =  
		  CONVERT(xml,'<A><![CDATA[' 
		  + [DropCommands] + CHAR(13) + CHAR(10) + 'GO' + CHAR(13) + CHAR(10)
		  + [FunctionDefinition] + CHAR(13) + CHAR(10)+ 'GO' + CHAR(13) + CHAR(10)
		  + [TableDefinition] + CHAR(13) + CHAR(10)+ 'GO' + CHAR(13) + CHAR(10)
		  + [ProcedureDefinitions] + CHAR(13) + CHAR(10)+ 'GO' + CHAR(13) + CHAR(10)
		  + [JobDefinition] + CHAR(13) + CHAR(10)+ 'GO' + CHAR(13) + CHAR(10)
		  + [RptJobDefinition]  + CHAR(13) + CHAR(10)+ 'GO' + CHAR(13) + CHAR(10)
		  + ']]></A>') 
   FROM #Results