--#################################################################################################
-- 2025-06-03 06:23:38.062 MachineName:ViscosityLowell; ComputerBiosName:VISCOSITYLOWELL;  
-- ApplicationName: DBA | AppEmailGroup: lowell.izaguirre@viscosityna.com | ServerUptime[dd:hh:mm:ss]: 01:23:39:24
-- Cname: wks-lowell.workgroup,;  LoginName: VISCOSITYLOWELL\lowell Authorization Scheme: NTLM viscositylowell
-- Context: ViscosityLowell,; Database:master; Version: [SQL 2022 || 16.0.4165.4] Developer Edition (64-bit)
--#################################################################################################
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
--desc: warning: very CPU intensive/long running: finds all plans with implicit conversions, as a target for tuning
IF OBJECT_ID('tempdb..[#ImplicitOrder]') IS NOT NULL 
DROP TABLE [#ImplicitOrder] 
GO
;WITH MyCTE(orderID,DataType)
AS
(SELECT 1,'xml' UNION ALL
SELECT 2,'datetimeoffset' UNION ALL     SELECT 3,'datetime2' UNION ALL
SELECT 4,'datetime' UNION ALL           SELECT 5,'smalldatetime' UNION ALL
SELECT 6,'date' UNION ALL               SELECT 7,'time' UNION ALL
SELECT 8,'float' UNION ALL              SELECT 9,'real' UNION ALL
SELECT 10,'decimal' UNION ALL           SELECT 11,'money' UNION ALL
SELECT 12,'smallmoney' UNION ALL        SELECT 13,'bigint' UNION ALL
SELECT 14,'int' UNION ALL               SELECT 15,'smallint' UNION ALL
SELECT 16,'tinyint' UNION ALL           SELECT 17,'bit' UNION ALL
SELECT 18,'ntext' UNION ALL             SELECT 19,'text' UNION ALL
SELECT 20,'image' UNION ALL             SELECT 21,'timestamp' UNION ALL
SELECT 22,'uniqueidentifier' UNION ALL  SELECT 23,'nvarchar ' UNION ALL
SELECT 23,'nvarchar(max)' UNION ALL     SELECT 24,'nchar' UNION ALL
SELECT 25,'varchar' UNION ALL           SELECT 25,'varchar(max) )' UNION ALL
SELECT 26,'char' UNION ALL              SELECT 27,'varbinary' UNION ALL
SELECT 27,'varbinary(max)' UNION ALL    SELECT 28,'binary'
)
SELECT * INTO #ImplicitOrder FROM MyCTE;
DECLARE @dbname sysname; 
SET @dbname = QUOTENAME(DB_NAME());

WITH XMLNAMESPACES 
   (DEFAULT 'http://schemas.microsoft.com/sqlserver/2004/07/showplan') 
SELECT 
   [stmt].[value]('(@StatementText)[1]', 'varchar(max)') AS Command, 
   [t].[value]('(ScalarOperator/Identifier/ColumnReference/@Schema)[1]', 'varchar(128)') AS SchemaName, 
   [t].[value]('(ScalarOperator/Identifier/ColumnReference/@Table)[1]', 'varchar(128)')  AS TableName, 
   [t].[value]('(ScalarOperator/Identifier/ColumnReference/@Column)[1]', 'varchar(128)') AS ColumnName, 
   [ic].[DATA_TYPE] AS [ConvertFrom], 
   [ic].[CHARACTER_MAXIMUM_LENGTH] AS [ConvertFromLength], 
   [t].[value]('(@DataType)[1]', 'varchar(128)') AS [ConvertTo], 
   [t].[value]('(@Length)[1]', 'int') AS [ConvertToLength], 
   CASE 
    WHEN ordFrom.orderID < ordTo.orderID THEN 'bad implicit conversion'
    WHEN ordFrom.orderID = ordTo.orderID THEN 'size implicit conversion'
    WHEN ordFrom.orderID > ordTo.orderID THEN 'ok implicit conversion'
  END AS ImplicitConversionNotes,
   [qp].[query_plan] 
FROM [sys].[dm_exec_cached_plans] AS [cp] 
CROSS APPLY [sys].[dm_exec_query_plan]([cp].[plan_handle]) AS [qp] 
CROSS APPLY [query_plan].[nodes]('/ShowPlanXML/BatchSequence/Batch/Statements/StmtSimple') AS [batch]([stmt]) 
CROSS APPLY [stmt].[nodes]('.//Convert[@Implicit="1"]') AS [n]([t]) 
JOIN [INFORMATION_SCHEMA].[COLUMNS] AS [ic] 
   ON QUOTENAME([ic].[TABLE_SCHEMA]) = [t].[value]('(ScalarOperator/Identifier/ColumnReference/@Schema)[1]', 'varchar(128)') 
   AND QUOTENAME([ic].[TABLE_NAME]) = [t].[value]('(ScalarOperator/Identifier/ColumnReference/@Table)[1]', 'varchar(128)') 
   AND [ic].[COLUMN_NAME] = [t].[value]('(ScalarOperator/Identifier/ColumnReference/@Column)[1]', 'varchar(128)') 
   INNER JOIN #ImplicitOrder ordFrom ON [ic].[DATA_TYPE] = ordFrom.DataType
   INNER JOIN  #ImplicitOrder ordTo ON [t].[value]('(@DataType)[1]', 'varchar(128)') = ordTo.DataType
WHERE [t].[exist]('ScalarOperator/Identifier/ColumnReference[@Database=sql:variable("@dbname")][@Schema!="[sys]"]') = 1;