--#################################################################################################
-- 2025-06-03 06:45:34.702 MachineName:ViscosityLowell; ComputerBiosName:VISCOSITYLOWELL;  
-- ApplicationName: DBA | AppEmailGroup: lowell.izaguirre@viscosityna.com | ServerUptime[dd:hh:mm:ss]: 02:00:01:21
-- Cname: wks-lowell.workgroup,;  LoginName: VISCOSITYLOWELL\lowell Authorization Scheme: NTLM viscositylowell
-- Context: ViscosityLowell,; Database:master; Version: [SQL 2022 || 16.0.4165.4] Developer Edition (64-bit)
--#################################################################################################
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
SELECT 
    DB_NAME() AS DatabaseName,
    sch_referencing.[name] AS ReferencingSchema,
    obj_referencing.[name] AS ReferencingObject,
    obj_referencing.[type_desc] AS ReferencingObjectType,

    sch_referenced.[name] AS ReferencedSchema,
    obj_referenced.[name] AS ReferencedObject,
    obj_referenced.[type_desc] AS ReferencedObjectType
FROM sys.sql_expression_dependencies d
INNER JOIN sys.objects obj_referencing ON d.referencing_id = obj_referencing.[object_id]
INNER JOIN sys.schemas sch_referencing ON obj_referencing.[schema_id] = sch_referencing.[schema_id]

INNER JOIN sys.objects obj_referenced ON d.referenced_id = obj_referenced.[object_id]
INNER JOIN sys.schemas sch_referenced ON obj_referenced.[schema_id] = sch_referenced.[schema_id]

WHERE obj_referencing.[type] IN ('P','V','FN','IF','TF') -- procs, views, scalar UDFs, inline TVF, multi TVF
  AND obj_referenced.[type] IN ('FN','TF','V','S','P') -- scalar UDF, TVF, views, tables, system objects, procs
ORDER BY 
    ReferencingSchema, ReferencingObject, ReferencedSchema, ReferencedObject;